]> git.pld-linux.org Git - packages/rpm-build-macros.git/blob - rpm.macros
- full path to __make friends (what r1.525 removed)
[packages/rpm-build-macros.git] / rpm.macros
1 # $Revision$, $Date$
2 # PLD Linux rpm macros.
3 # <http://www.pld-linux.org/>
4
5 %epoch          0
6 %x8664          x86_64 amd64 ia32e
7
8 # kernel compiler
9 %kgcc           %{__cc}
10 %kgcc_package   gcc
11
12 # compiler version
13 %cc_version     %{expand:%%global cc_version %(%{__cc} -dumpversion || echo ERROR)}%cc_version
14 %cxx_version    %{expand:%%global cxx_version %(%{__cxx} -dumpversion || echo ERROR)}%cxx_version
15
16 %__rm           /bin/rm --interactive=never
17
18 # Build system path macros.
19 %__autoconf     autoconf %{?debug:-Wall}
20 %__automake     automake -a -c -f --foreign
21 %__autopoint    autopoint --force
22
23 # add parallel build flags: -jN
24 #
25 # if you want to disable parallel build do:
26 # echo '%_smp_mflags %{nil}' >> ~/.rpmmacros
27 #
28 %__make         /usr/bin/make %{?_smp_mflags}
29 %__scons        /usr/bin/scons %{?_smp_mflags}
30 %__waf          /usr/bin/waf %{?_smp_mflags}
31 %__cmake        /usr/bin/cmake %{?_smp_mflags}
32
33 %_smp_mflags %(_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); \\\
34                                 [ "$_NCPUS" -gt 1 ] && echo "-j$(($_NCPUS * 2))")
35
36 %__gettextize { \
37         if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
38                 gettextize --copy --force --no-changelog; \
39         else \
40                 gettextize --copy --force --no-changelog --intl; \
41         fi; \
42         if [ ! -f po/Makevars ]; then \
43                 cp -f po/Makevars{.template,}; \
44         fi; \
45 }
46
47 %__glib_gettextize      glib-gettextize --copy --force
48 %__gnome_doc_common     gnome-doc-common --copy
49 %__gnome_doc_prepare    gnome-doc-prepare --copy --force
50 %__gtkdocize            gtkdocize --copy
51 %__intltoolize          intltoolize --copy --force
52 %__libtoolize           libtoolize --copy --force --install
53
54 #       Path to top of build area.
55 %_topdir                %{expand:%%global _topdir %(test -d ../SPECS -a -d ../SOURCES && (cd ..; pwd) || echo $HOME/rpm)}%_topdir
56
57 #       The number of cvs changelog entries kept when building package.
58 %_buildchangelogtruncate 20
59
60 %dependencytracking     %{nil}
61
62 #       Relations between package names that cause dependency loops
63 #       with legacy packages that cannot be fixed. Relations are
64 #       specified as
65 #               p>q
66 #       where package p has a Requires: on something that package q Provides:
67 #
68 # XXX   Note: that there cannot be any whitespace within the string "p>q",
69 #       and that both p and q are package names (i.e. no version/release).
70 %_dependency_whiteout   %{nil}
71
72 #-----------------------------------------------------------------
73 #
74 # (re)definition of %{rpm*flags} with %filterout_* support
75 # BuildRequires:        awk
76 # BuildRequires:        rpmbuild(macros) >= 1.315
77 #
78 # Flags specified in %filterout_* are removed from %rpm*flags, exactly:
79 # %rpmcflags    = %optflags - %filterout - %filterout_c   - %filterout_ld
80 # %rpmcxxflags  = %optflags - %filterout - %filterout_cxx - %filterout_ld
81 # %rpmcppflags  = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
82 # %rpmldflags   = %optldflags - %filterout_ld
83 #
84 # Regular expressions are supported, but to avoid some character be treated
85 # as regular expression it must be escaped twice.
86
87 %filter_out                                             \
88         for (i = 1; i in I; i++) {      A=0;    \
89                 for (f in F) {                          \
90                         if (I[i] ~ "^" F[f] "$") A=1;   \
91                 };                                                      \
92                 if (!A) printf(I[i] FS);        \
93         }
94
95 %rpmcflags %(awk 'BEGIN {
96         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
97         split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
98         %{filter_out}
99 }')
100
101 %rpmcxxflags %(awk 'BEGIN {
102         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
103         split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
104         %{filter_out}
105 }')
106
107 %rpmcppflags %(awk 'BEGIN {
108         split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
109         split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
110         %{filter_out}
111 }')
112
113 %rpmldflags %(awk 'BEGIN {
114         split("%{?optldflags}",I);
115         split("%{?filterout_ld}",F)
116         %{filter_out}
117 }')
118
119 # rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
120 # but, don't use it, better use gcc as linker
121 %ld_rpmldflags %(awk 'BEGIN {
122         split("%{rpmldflags}",F);
123         for (f in F) {
124                 s = F[f];
125                 if (s ~ /^-Wl,/) {
126                         s = substr(s,5);
127                         gsub(/,/," ",s);
128                 };
129                 printf(s FS);
130         };
131 }')
132
133 #-----------------------------------------------------------------
134 #
135 #  Generate a command which cleans environment, leaving only the
136 # most important variables.
137 #  If any spec requires any additional environment it should
138 # redefine %_preserve_env in following manner:
139 #
140 #       # ADDITIONAL_VAR is required because [a good reason here]
141 #       %define _preserve_env ADDITIONAL_VAR
142
143 %_preserve_env_base     PATH HOME TMP TMPDIR SSH_AUTH_SOCK
144
145 # "env -i" must end in first line of expaned macros because it's used as first line of shell script (#! env...)
146 %_clean_env             %{!?_preserve_env:%global _preserve_env %{nil}}%{expand:%%global _preserve_env %{_preserve_env} %_preserve_env_base} env -i %(awk -vq="'" -vqq="\\"'\\"" -vq2q="'\\"'" 'BEGIN {
147         split("%{?_preserve_env}", P);
148         for (i in P) {
149                 p = P[i];
150                 if (!ENVIRON[p] || d[p]) {
151                         continue;
152                 }
153                 d[p] = 1;
154                 split(ENVIRON[p], V, "");
155                 val = p "=";
156                 for (j = 1; j in V; j++) {
157                         v = V[j];
158                         if (v == q)
159                                 v = qq;
160                         else if (v == "\\"")
161                                 v = q2q;
162                         else if (v == "\\\\")
163                                 v = "\\\\\\\\";
164                         else
165                                 gsub("[^a-zA-Z0-9/:._-]", "\\"&\\"", v);
166                         val = val "" v;
167                 }
168                 printf(val " ");
169         }
170 }')
171
172 #-----------------------------------------------------------------
173 %configure2_13 { \
174  if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
175  LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
176  CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
177  CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
178  FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
179  FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
180  CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
181  %{?__cc:CC="%{__cc}" ; export CC ; } \
182  %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
183  %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
184         --host=%{_target_platform} \
185         --prefix=%{_prefix} \
186         --exec-prefix=%{_exec_prefix} \
187         --bindir=%{_bindir} \
188         --sbindir=%{_sbindir} \
189         --sysconfdir=%{_sysconfdir} \
190         --datadir=%{_datadir} \
191         --includedir=%{_includedir} \
192         --libdir=%{_libdir} \
193         --libexecdir=%{_libexecdir} \
194         --localstatedir=%{_localstatedir} \
195         --sharedstatedir=%{_sharedstatedir} \
196         --mandir=%{_mandir} \
197         --infodir=%{_infodir} \
198         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
199         %{dependencytracking} \
200 }
201
202 %cmake { \
203 CC="%{__cc}" \
204 CXX="%{__cxx}" \
205 CFLAGS="%{rpmcflags}" \
206 CXXFLAGS="%{rpmcxxflags}" \
207 LDFLAGS="%{rpmldflags}" \
208 %{__cmake} \
209 }
210
211 %scons { \
212 %{__scons} \
213         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
214         CFLAGS="${CFLAGS:-%rpmcflags}" \
215         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
216         FFLAGS="${FFLAGS:-%rpmcflags}" \
217         CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
218         %{?__cc:CC="%{__cc}"} \
219         %{?__cxx:CXX="%{__cxx}"} \
220         libsuffix=%{_lib} \
221         prefix=%{_prefix} \
222 }
223
224 # waf. see waf.spec
225 %waf { \
226 CC="%{__cc}" \
227 CXX="%{__cxx}" \
228 CPP="%{__cpp}" \
229 CFLAGS="%{rpmcflags}" \
230 CXXFLAGS="%{rpmcxxflags}" \
231 %{__waf} \
232 }
233
234 #----------------------------------------------------------------
235 #%configure_cache 0
236 %configure_cache_file   %{buildroot}.configure.cache
237
238 %configure {./configure \
239         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
240         CFLAGS="${CFLAGS:-%rpmcflags}" \
241         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
242         FFLAGS="${FFLAGS:-%rpmcflags}" \
243         FCFLAGS="${FCFLAGS:-%rpmcflags}" \
244         CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
245         %{?__cc:CC="%{__cc}"} \
246         %{?__cxx:CXX="%{__cxx}"} \
247         --host=%{_target_platform} \
248         --build=%{_target_platform} \
249         --prefix=%{_prefix} \
250         --exec-prefix=%{_exec_prefix} \
251         --bindir=%{_bindir} \
252         --sbindir=%{_sbindir} \
253         --sysconfdir=%{_sysconfdir} \
254         --datadir=%{_datadir} \
255         --includedir=%{_includedir} \
256         --libdir=%{_libdir} \
257         --libexecdir=%{_libexecdir} \
258         --localstatedir=%{_localstatedir} \
259         --sharedstatedir=%{_sharedstatedir} \
260         --mandir=%{_mandir} \
261         --infodir=%{_infodir} \
262         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
263         %{dependencytracking} \
264         %{?configure_cache:--cache-file=%{configure_cache_file}} \
265 }
266
267 # overload to insert debuginfo package
268 %prep \
269 %if 0%{?_enable_debug_packages}\
270 %{debug_package}\
271 %endif\
272 %%prep\
273 %{nil}
274
275 # Location of autoconf macros
276 %_aclocaldir    %{expand:%%global _aclocaldir %(aclocal --print-ac-dir || echo ERROR)}%_aclocaldir
277
278 # Location of omf files
279 %_omf_dest_dir  %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
280
281 # Location of pkgconfig files
282 %_pkgconfigdir  /usr/%{_lib}/pkgconfig
283 # noarch pkgconfig files
284 %_npkgconfigdir /usr/share/pkgconfig
285
286 # Location of desktop files
287 %_desktopdir    /usr/share/applications
288 %_applnkdir     ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
289
290 # Location of pixmaps for applnk/desktop files
291 %_pixmapsdir    /usr/share/pixmaps
292
293 # Location of themable icons for applnk/desktop files
294 %_iconsdir      /usr/share/icons
295
296 # Location of fonts directories
297 %_fontsdir      /usr/share/fonts
298
299 # Location of Gtk and associated libraries documentation
300 %_gtkdocdir     %{_defaultdocdir}/gtk-doc/html
301
302 # Location of KDE documentation
303 %_kdedocdir     %{_defaultdocdir}/kde/HTML
304
305 # unsermake script
306 %__unsermake /usr/share/unsermake/unsermake
307
308 # Current date
309 %date           %(LC_ALL=C date +"%a %b %d %Y")
310
311 # Example files, programs, scripts...
312 %_examplesdir   /usr/src/examples
313
314 # Alternative kernel type/version
315 %_alt_kernel    %{nil}%{?alt_kernel:-%{?alt_kernel}}
316
317 # The directory holding Linux kernel sources
318 %_kernelsrcdir  /usr/src/linux%{_alt_kernel}
319
320 # SysV-style initscripts dir
321 %_initddir              /etc/rc.d/init.d
322
323 # If non-empty "debug" macro defined, add "dbg" suffix to release number
324 %_rpmfilename           %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
325
326
327 %releq_kernel                   %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
328 %releq_kernel_up                %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
329 %releq_kernel_smp()             %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
330 %requires_releq_kernel(s:)              Requires%{-s:(%{-s*})}: %releq_kernel
331 %requires_releq_kernel_up(s:)   Requires%{-s:(%{-s*})}: %releq_kernel_up
332 %requires_releq_kernel_smp(s:)  Requires%{-s:(%{-s*})}: %releq_kernel_smp
333
334 # Requires name = version-release
335 %requires_releq()       %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to -r %1 %1}}}
336 # Requires: name = version
337 %requires_eq()          %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to %1 %1}}}
338 # Requires: name = version (version based on querying package %2)
339 %requires_eq_to(r)      %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
340
341 %apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
342
343 # kernel version-release handling
344 %__kernel_ver    %{expand:%%global __kernel_ver %( \\
345         Z=$(awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
346         Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
347         echo ${Z:-ERROR}; \\
348 )}%__kernel_ver
349
350 %__kernel_rel   %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
351 %__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
352 %_kernel_ver    %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
353 %_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
354
355 # `uname -r` to be used in @release field
356 %_kernel_vermagic       %{expand:%%global _kernel_vermagic %(echo %{_kernel_ver} | sed -e 's/-/_/g')}%_kernel_vermagic
357
358 # sgml macros
359 %xmlcat_add()           /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
360 %xmlcat_del()           /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
361 %xmlcat_add_rewrite     /usr/bin/xmlcatalog --noout --add rewriteSystem
362 %xmlcat_create()        /usr/bin/xmlcatalog --noout --create %1 ;
363 %sgmlcat_add()          /usr/bin/install-catalog --add %1 %2 > /dev/null ;
364 %sgmlcat_del()          /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
365 %docbook_sgmlcat_fix() { for l in \
366 '' \
367 '  -- default decl --' \
368 'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
369 '  -- hacks for opensp --' \
370 'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
371 'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd"                  "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
372 '' \
373 ; do echo $l; done >> %1 \
374 }
375
376 # vim - "
377
378 # minimum file size needed for compressed documents.
379 # just smaller files than this get larger when compressed.
380 # some stats:
381 # - 0 byte file compressed was 25 bytes .gz
382 # - 39 byte file was compressed as 57
383 # - with test/test.spec@man 158 byte file was compressed also 158
384 %_min_compress_bytes    159
385
386 #-----------------------------------------------------------------
387 # find and gzip all files in %{_mandir} and %{infodir}
388 #
389 # Requires: xargs, find
390 #
391 #%no_install_post_compress_docs 1
392 %__spec_install_post_compress_docs { \
393 %{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
394         for i in /usr/share/man /usr/X11R6/man; do \
395                 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
396                         echo "Compress man pages: $i"; \
397                         find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
398                         find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
399                         find $RPM_BUILD_ROOT$i -type l | while read a; do \
400                                 m=$(readlink $a); \
401                                 rm -f $a; \
402                                 echo .so ${m##*/} > $a; \
403                                 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
404                         done; \
405                         find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
406                 fi; \
407         done; \
408         if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
409                 echo "Compress info pages: %{_infodir}"; \
410                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
411                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
412                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
413         fi; \
414 }; __spec_install_post_compress_docs } }
415
416 #-----------------------------------------------------------------
417 # Strip executable binaries and shared object files
418 #
419 # Requires: find, awk, strip, cut, xargs
420 #
421 # Special macros which affect this process:
422 #%no_install_post_strip 1               # disable stripping at all
423 #%_noautostrip                  regexp  # exclude files matching (anchored!) regex from stripping
424 #%_autostripall                 regexp  # strip files matching (anchored!) regex using plain strip
425 #%_autostripunneeded    regexp  # strip files matching (anchored!) regex using strip --strip-unneeded
426 #%_autostripdebug               regexp  # strip files matching (anchored!) regex using strip --strip-debug
427 #
428 %__spec_install_post_strip {%{!?debug: \
429 %{!?no_install_post_strip:__spec_install_post_strip() { \
430 if [ -d "$RPM_BUILD_ROOT" ]; then \
431         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
432                 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
433                 if [ "$modulelist" ]; then \
434                         modulecount=$(echo "$modulelist" | wc -l); \
435                         printf "Stripping %d kernel modules..." $modulecount; \
436                         echo "$modulelist" | xargs -l512 chmod u+w; \
437                         echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
438                         echo "DONE"; \
439                 fi; \
440         fi; \
441         filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
442         if [ -n "$filelist" ]; then \
443                 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
444                 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
445                 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
446                 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
447                 if [ -n "$elfexelist" ]; then \
448                         printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
449                         chmod u+w $elfexelist; \
450                         %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
451                         echo "DONE"; \
452                 fi; \
453                 if [ -n "$elfsharedlist" ]; then \
454                         printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
455                         chmod u+w $elfsharedlist; \
456                         %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
457                         echo "DONE"; \
458                 fi; \
459                 if [ -n "$archiveslist" ]; then \
460                         printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
461                         chmod u+w $archiveslist; \
462                         %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
463                         echo "DONE"; \
464                 fi; \
465         fi; \
466     filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
467     filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
468     filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
469         if [ -n "$filelist_all" ]; then \
470                 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
471                 chmod u+w $filelist_all; \
472                 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
473                 echo "DONE"; \
474         fi; \
475         if [ -n "$filelist_unneeded" ]; then \
476                 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
477                 chmod u+w $filelist_unneeded; \
478                 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
479                 echo "DONE"; \
480         fi; \
481         if [ -n "$filelist_debug" ]; then \
482                 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
483                 chmod u+w $filelist_debug; \
484                 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
485                 echo "DONE"; \
486         fi; \
487 fi; }; __spec_install_post_strip } } }
488
489 #-----------------------------------------------------------------
490 # remove all RPATH from executable binaries and shared object files
491 #
492 # Requires: find, awk, cut, xargs, chrpath, uname
493 #
494 # Special macros which affect this process
495 #%no_install_post_chrpath       1       # disable chrpath at all
496 #%_noautochrpath        regex           # exclude files matching (anchored!) regex from chrpath
497 #
498 %__spec_install_post_chrpath {%{!?debug: \
499 %{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
500 if [ -d "$RPM_BUILD_ROOT" ]; then \
501         files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
502         if [ -n "$files" ]; then \
503                 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
504         fi; \
505         if [ -n "$objs" ]; then \
506                 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
507                 echo "$objs" | \
508                 while read file; do \
509                         rpath= ; \
510                         chmod u+w "$file"; \
511                         for dir in $(chrpath -l "$file" | awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'); do \
512                                         case $dir in \
513                                         '$ORIGIN' ) \
514                                                 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
515                                                 else rpath="$rpath:$dir" ; fi ; \
516                                                 continue ; \
517                                                 ;; \
518                                         esac ; \
519                                         newdir=$(readlink -m "$dir"); \
520                                         [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
521                                         case $dir in \
522                                         /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
523                                                 echo "remove-rpath: $dir in $file"; \
524                                                 ;; \
525                                         * ) \
526                                                 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
527                                                 else rpath="$rpath:$dir" ; fi ; \
528                                                 ;; \
529                                         esac ; \
530                         done ; \
531                         if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
532                         else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
533                 done; \
534         fi; \
535 fi; }; __spec_install_post_chrpath } } }
536
537 #-----------------------------------------------------------------
538 # Find all shared object files with unresolved symbols. Warn
539 # and terminate if any found (termination can be turned off by define).
540 #%no_install_post_check_so 1
541 %__spec_install_post_check_so { \
542  __spec_install_post_check_so() { \
543     fail=0; \
544     printf "Searching for shared objects with unresolved symbols..."; \
545     for f in $(find $RPM_BUILD_ROOT -type f -name '*.so.*' -print); do \
546         LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; skip["program_name"]=1; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { if ($NF in skip) { next; }; found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "\nUnresolved symbols found in: " file symbols; exit(1); } } ' || fail=1 ; \
547     done ; \
548     echo " DONE"; \
549     %{!?no_install_post_check_so:[ $fail -eq 1 ] && : || :;} \
550 }; __spec_install_post_check_so }}
551
552 #-----------------------------------------------------------------
553 # Find and gzip all kernel modules
554 #
555 # Requires: find
556 #
557 #%no_install_post_compress_modules      1
558 %__spec_install_post_compress_modules { \
559 %{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
560         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
561                 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
562                 if [ "$q" ]; then \
563                         printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
564                         echo "$q" | xargs -r %{__gzip} -9nf; \
565                         echo "DONE"; \
566                         find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
567                         while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
568                 fi; \
569         fi; \
570 }; __spec_install_post_compress_modules } }
571
572 # Remove common Perl files we don't package
573 %__spec_install_post_perl_clean {\
574 %{!?no_install_post_perl_clean: \
575 %{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
576 } }
577
578 #-----------------------------------------------------------------
579 # Update GConf2 schemas
580 #
581 # Requires: GConf2
582 #
583 %gconf_schema_install() \
584         umask 022; \
585         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
586         /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
587 %{nil}
588
589 %gconf_schema_uninstall() \
590 if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
591         umask 022; \
592         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
593         /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
594 fi; \
595 %{nil}
596
597 #-----------------------------------------------------------------
598 # Update desktop MIME database
599 # requires: desktop-file-utils
600 %update_desktop_database() {{ \
601         umask 022; \
602         /usr/bin/update-desktop-database -q; \
603 };} \
604 %{nil}
605
606 %update_desktop_database_post %update_desktop_database
607
608 %update_desktop_database_postun() {{ \
609 if [ "$1" = "0" ]; then \
610         %update_desktop_database \
611 fi; \
612 };} \
613 %{nil}
614
615 #-----------------------------------------------------------------
616 # Update shared MIME info database
617 # requires: shared-mime-info
618 #
619 %update_mime_database() {{ \
620         umask 022; \
621         /usr/bin/update-mime-database %{_datadir}/mime; \
622 };} \
623 %{nil}
624
625 #-----------------------------------------------------------------
626 # Update icon cache
627 # requires: gtk+
628 #
629 %update_icon_cache() {{ \
630         umask 022; \
631         /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
632 };} \
633 %{nil}
634
635 #-----------------------------------------------------------------
636 # Update scrollkeeper database
637 # requires: scrollkeeper
638 #
639 %scrollkeeper_update_post() \
640         /usr/bin/scrollkeeper-update -q; \
641 %{nil}
642
643 %scrollkeeper_update_postun() \
644 if [ "$1" = "0" ]; then \
645         /usr/bin/scrollkeeper-update -q; \
646 fi; \
647 %{nil}
648
649 #-----------------------------------------------------------------
650 # post %install sequence:
651 # - autodeps exceptions
652 # - compress all man and info pages,
653 # - strip all ELF executables and ELF shared objects if not %debug.
654 # - compress kernel modules if any
655
656 ###################################################################
657 # Requires/Provides automation
658 # exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
659 #
660 %__noautoreqfiles       %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
661 %__noautoprovfiles      %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
662 %__noautoreq            %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
663 %__noautoreqdep         %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
664 %__noautoprov           %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
665
666 #%_noautocompressdoc    %{nil}
667 #
668 %_missing_doc_files_terminate_build     1%{nil}
669 %_unpackaged_files_terminate_build      %{nil}
670 # (X)emacs support
671 %___emacs_lispdir_helper  -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
672 %_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
673 %_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
674
675 %__php_provides %{nil}
676 %__php_requires %{nil}
677 %__perl_provides %{nil}
678 %__perl_requires %{nil}
679 %__mono_provides %{nil}
680 %__mono_requires %{nil}
681
682 # Perl specific macro definitions.
683 %perl_privlib           %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
684 %perl_archlib           %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
685 %perl_vendorlib         %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
686 %perl_vendorarch        %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
687 %perl_sitelib           %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
688 %perl_sitearch          %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
689
690 # Ruby
691 %__ruby                         /usr/bin/ruby
692 %ruby_archdir           %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
693 %ruby_ridir                     %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
694 %ruby_rubylibdir        %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
695 %ruby_vendorarchdir     %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
696 %ruby_vendorlibdir      %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
697 %ruby_sitearchdir       %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
698 %ruby_sitelibdir        %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
699 %ruby_rdocdir           /usr/share/rdoc
700 %ruby_version           %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
701 %ruby_ver_requires_eq   Requires:       ruby(ver) = %ruby_version
702 %ruby_mod_ver_requires_eq       Requires:       ruby-modules(ver) = %ruby_version
703
704 %php_pear_dir           /usr/share/pear
705 %php_data_dir           /usr/share/php
706 %php_extensiondir       %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
707 %php_sysconfdir         %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
708 %php_includedir         %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
709
710 # extract php/zend api versions
711 %php_major_version              %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
712 %php_api_version                %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
713 %php_pdo_api_version    %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
714 %php_debug                              %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
715 %zend_module_api                %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
716 %zend_extension_api             %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
717 %zend_zts                               %{expand:%%global zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%zend_zts
718
719 # helper macro
720 %__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
721
722 # macros for public use
723 # for php extensions (php-pecl)
724 %requires_php_extension %{__php_api_requires modules_api php_api_version} \
725 %{__php_api_requires zend_module_api} \
726 %{__php_api_requires -v %php_major_version debug php_debug} \
727 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
728
729 # for zend extensions
730 %requires_zend_extension %{__php_api_requires zend_module_api} \
731 %{__php_api_requires zend_extension_api} \
732 %{__php_api_requires -v %php_major_version debug php_debug} \
733 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
734
735 # for php pdo modules (php-pecl-PDO_*)
736 %requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
737
738 # for using PHP post scripts. for PHP >= 5.0
739 %php_webserver_restart \
740 [ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
741 [ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
742 if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
743         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
744         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
745                 %service -q php-fcgi restart \
746         fi \
747 fi \
748 if [ -x /etc/rc.d/init.d/php-fpm ]; then \
749         %service -q php-fpm restart \
750 fi \
751 %{nil}
752
753 # for using php post scripts. for PHP >= 4.0 && PHP < 5.0
754 %php4_webserver_restart \
755 [ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
756 [ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
757 if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
758         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
759         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
760                 %service -q php-fcgi restart \
761         fi \
762 fi \
763 %{nil}
764
765 # X.org helper macros
766 %__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
767 %__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
768
769 %xorg_xserver_ansic_abi         %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
770 %xorg_xserver_extension_abi     %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
771 %xorg_xserver_font_abi          %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
772 %xorg_xserver_videodrv_abi      %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
773 %xorg_xserver_xinput_abi        %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
774
775 %requires_xorg_xserver_extension \
776 %{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
777 %{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
778 %{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
779 %{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
780 %{nil}
781
782 %requires_xorg_xserver_xinput \
783 %{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
784 %{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
785 %{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
786 %{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
787 %{nil}
788
789 %requires_xorg_xserver_font \
790 %{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
791 %{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
792 %{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
793 %{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
794 %{nil}
795
796 %requires_xorg_xserver_videodrv \
797 %{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
798 %{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
799 %{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
800 %{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
801 %{nil}
802
803 # TCL specific macro definitions.
804 # TODO: when th tcl is fixed use tclsh to get version: %(echo 'puts $tcl_version' | tclsh)
805 %tcl_version    %{expand:%%global tcl_version %(v=$(rpm -q --qf %{V} tcl | cut -d. -f1,2); echo ${v:-ERROR})}%tcl_version
806 %tcl_sitearch   %{_libdir}/tcl%{tcl_version}
807 %tcl_sitelib    %{_datadir}/tcl%{tcl_version}
808
809 # Python specific macro definitions.
810 # python main version
811 %py_ver                 %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
812
813 # directories
814 %py_prefix              %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
815 %py_libdir              %{py_prefix}/%{_lib}/python%{py_ver}
816 %py_scriptdir   %{py_prefix}/share/python%{py_ver}
817 %py_incdir              /usr/include/python%{py_ver}
818 %py_sitedir             %{py_libdir}/site-packages
819 %py_sitescriptdir %{py_scriptdir}/site-packages
820 %py_dyndir              %{py_libdir}/lib-dynload
821
822 # pure python modules compilation
823 %py_comp                python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
824
825 %py_ocomp               python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
826
827 # Software written in Python language require Python with main version
828 %pyrequires_eq() Requires:      %1
829
830 # Python 3.x
831 # python main version
832 %__python3                      python3
833 %py3_ver                        %{expand:%%global py3_ver %(%{__python3} -c "import sys; print(sys.version[:3])" 2>/dev/null || echo ERROR)}%py3_ver
834
835 # directories
836 %py3_prefix             %{expand:%%global py3_prefix %(%{__python3} -c "import sys; print(sys.prefix)" 2>/dev/null || echo ERROR)}%py3_prefix
837 %py3_libdir             %{py3_prefix}/%{_lib}/python%{py3_ver}
838 %py3_scriptdir  %{py3_prefix}/share/python%{py3_ver}
839 %py3_incdir             /usr/include/python%{py3_ver}
840 %py3_sitedir            %{py3_libdir}/site-packages
841 %py3_sitescriptdir %{py3_scriptdir}/site-packages
842 %py3_dyndir             %{py3_libdir}/lib-dynload
843
844 # pure python modules compilation
845 %py3_comp               %{__python3} -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
846
847 %py3_ocomp              %{__python3} -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
848
849 # Hardlink binary identical .pyc and .pyo files
850 %__spec_install_post_py_hardlink {\
851 %{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
852 local a b c=0 t=0; \
853 if [ -d "$RPM_BUILD_ROOT" ]; then \
854         find "$RPM_BUILD_ROOT" -name '*.pyc' > __rpm_pyc; \
855         while read a; do \
856                 b="${a%.pyc}.pyo"; \
857                 if cmp -s "$a" "$b"; then \
858                         ln -f "$a" "$b"; \
859                         c=$((c + 1)); \
860                 fi; \
861                 t=$((t + 1)); \
862         done < __rpm_pyc; \
863         [ $t -gt 0 ] && printf "Hardlink Python files: %d/%d files hardlinked\n" $c $t; \
864         rm -f __rpm_pyc; \
865 fi; \
866 }; __spec_install_post_py_hardlink } }
867
868 # remove python sources, so that check-files won't complain
869 %py_postclean() \
870 for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
871  [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
872 done \
873 %{nil}
874
875 %py3_postclean() \
876 for d in %{py3_sitescriptdir} %{py3_sitedir} %*; do \
877  [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
878 done \
879 %{nil}
880
881 # depmod macro
882 %depmod() { \
883 umask 022; \
884 if [ -e /boot/System.map-%1 ]; then \
885         /sbin/depmod -a -F /boot/System.map-%1 %1; \
886 else \
887         if [ -e /boot/System.map ]; then \
888                 /sbin/depmod -a -F /boot/System.map %1; \
889         else \
890                 /sbin/depmod -a %1; \
891         fi \
892 fi; \
893 }
894
895 # XMMS specific macros
896 %xmms_prefix                    %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
897 %xmms_exec_prefix               %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
898 %xmms_version                   %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
899 %xmms_datadir                   %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
900 %xmms_plugindir                 %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
901 %xmms_visualization_plugindir   %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
902 %xmms_input_plugindir           %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
903 %xmms_output_plugindir          %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
904 %xmms_effect_plugindir          %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
905 %xmms_general_plugindir         %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
906
907 %_target_base_arch      %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/;s/sparcv./sparc/')}%_target_base_arch
908
909 # user/group checking macros
910 #
911 # Usage:
912 #       %userremove myuser
913 #
914 %userremove     /usr/lib/rpm/user_group.sh user del
915 %groupremove    /usr/lib/rpm/user_group.sh group del
916 #
917 # Usage:
918 #       if %usertestrm myuser; then
919 #               /usr/sbin/userdel -r myuser
920 # Note:
921 #       use these macros only if you need to call userdel/groupdel with
922 #       a non-standard option or take an extra action; otherwise use the
923 #       %userremove/%groupremove macros
924 #
925 %usertestrm     /usr/lib/rpm/user_group.sh user testrm
926 %grouptestrm    /usr/lib/rpm/user_group.sh group testrm
927 # user group membership management macros
928 #
929 # Usage:
930 #       %addusertogroup [-q] myuser agroup
931 #
932 #  -q if user or group don't exist, don't make big noise of it (MISSINGOK behaviour)
933 #
934 # Requirements:
935 # BuildRequires:        rpmbuild(macros) >= 1.515
936 %addusertogroup(q)      quiet=%{-q:1} /usr/lib/rpm/user_group.sh user addtogroup %*; \
937 %{nil}
938
939 # banner support (useful in {pre,post}{,un} and triggers)
940 #
941 # Usage:
942 #       %banner name [-a] [-e] [-n] [-tn] <<EOF
943 # the banner text, the banner text
944 # the banner text, and following line
945 #EOF
946 # You can use any form of here-document, <<'EOF' <<-EOT will do.
947 # NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
948 #
949 # -a   - append to the banner
950 # -e   - send to stderr instead of stdout
951 # -n   - no show banner (overrides -t)
952 # -t   - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
953 #
954 # Tests:
955 # (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
956 # rpm -E 'date | %banner -e banner' > m; sh -x m
957 #
958 %banner(aent:) ( \
959 RPM_SCRIPTVERBOSITY=5 \
960 [ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
961 if [ -x /usr/bin/banner.sh ]; then \
962         CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
963 else \
964         CMD="cat%{-e: >&2}" \
965 fi \
966 eval $CMD %{?2:%2}%{?3: %3}) \
967 %{nil}
968
969 # useradd/groupadd macros
970 # Author: Elan Ruusamäe <glen@pld-linux.org>
971 #
972 # Usage:
973 #   %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
974 #   [-g initial_group] [-G group[,...]] login
975 #
976 #  -u uid. REQUIRED
977 #  -g gid/group. REQUIRED
978 #  -s defaults to /bin/false
979 #  -d defaults to /usr/share/empty
980 #  -c No default
981 #  -r is accepted but ignored (it's always set)
982 #  -k skeleton dir. defaults to /usr/share/empty
983 # rpm specific flags
984 #  -P package name. defaults to %{name}
985 #
986 %useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
987 %{!-u:%{error:useradd: Required argument -u missing}} \
988 %{!-g:%{error:useradd: Required argument -g missing}} \
989 %{!?1:%{error:useradd: Required parameter login missing}} \
990 if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
991         if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
992                 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
993                 exit 1 \
994         fi \
995 else \
996         echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
997         /usr/sbin/useradd \\\
998                 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
999                 -u %{-u*} \\\
1000                 -r \\\
1001                 -d %{-d*}%{!-d:/usr/share/empty} \\\
1002                 -s %{-s*}%{!-s:/bin/false} \\\
1003                 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
1004                 -g %{-g*} \\\
1005                 %{-M} \\\
1006                 %{-G:-G %{-G*}} \\\
1007                 %{expand:%{%{#}}} 1>&2 || exit $? \
1008         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
1009 fi;
1010
1011 # Usage:
1012 #   %groupadd [-P package] [-g gid] group
1013 #
1014 # -g gid. REQUIRED
1015 #
1016 # Sample:
1017 #   %groupadd -P %{name}-base -g %{gid} %{name}
1018
1019 %groupadd(g:P:rfo)      \
1020 %{!-g:%{error:groupadd: Required argument -g missing}} \
1021 %{!?1:%{error:groupadd: Required parameter group missing}} \
1022 if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
1023         if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
1024                 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1025                 exit 1 \
1026         fi \
1027 else \
1028         echo "Adding group %{1} GID=%{-g*}." \
1029         /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
1030         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
1031 fi;
1032
1033 # webapp macros
1034 # Author: Elan Ruusamäe <glen@pld-linux.org>
1035 #
1036 # The config is installed/removed inside trigger, this means that you can any
1037 # time install apache1/apache/lighttpd package and the configuration file is
1038 # updated. if you don't need the config for various reason for specific
1039 # webserver, just remove the symlink from config directory using webapp
1040 # program. the trigger will not recreate the symlink on upgrades. In other
1041 # words the config is linked to webserver config directory on first install of
1042 # PACKAGE or WEBSERVER.
1043 #
1044 # Add package's webserver config to webserver webapps dir.
1045 # Usage:
1046 #   %webapp_register [-f] WEBSERVER WEBAPP
1047 #
1048 %webapp_register(f) \
1049 %{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
1050 if [ -n "%{-f:1}" ] || [ "$1" = "1" ] && [ "$2" = "1" ]; then\
1051         /usr/sbin/webapp register %1 %2\
1052 fi\
1053 # reload webserver if the config symlink is there and skip reload if webserver is upgraded\
1054 if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
1055         %{expand:%service -q %%1 reload}\
1056 fi\
1057 %{nil}
1058
1059 # Remove package's config from webserver webapps dir.
1060 # Usage:
1061 #   %webapp_register [-f] WEBSERVER WEBAPP
1062 %webapp_unregister(f) \
1063 %{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
1064 # remove link if either of the packages are gone \
1065 if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
1066         /usr/sbin/webapp unregister %1 %2\
1067         %{expand:%service -q %%1 reload}\
1068 fi \
1069 %{nil}
1070
1071 # service macro.
1072 # Author: Elan Ruusamäe <glen@pld-linux.org>
1073 #
1074 # calls usual service restart on package %post, but skips the restart if
1075 # administrator has disabled automatic service restarts in either global
1076 # /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
1077 #
1078 # Usage:
1079 #   %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
1080 #
1081 #  -q be silent when service isn't started (for scriplets restaring other package's services)
1082 #  -n NOOP mode, do not actually restart service
1083 #
1084 # Requirements:
1085 # BuildRequires:        rpmbuild(macros) >= 1.268
1086 # Requires:     rc-scripts
1087 # -n option:
1088 # BuildRequires:        rpmbuild(macros) >= 1.450
1089 %service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
1090
1091
1092 # Java macros. based on jpackage macros.java
1093 #
1094 # Root directory where all Java VMs/SDK/JREs are installed.
1095 %_jvmdir                %{_libdir}/jvm
1096
1097 # Root directory where all Java VMs/SDK/JREs expose their jars
1098 %_jvmjardir             %{_libdir}/jvm-exports
1099
1100 # Root directory for all Java VM/SDK/JRE's private things.
1101 %_jvmprivdir    %{_libdir}/jvm-private
1102
1103 # Root directory for all architecture dependent parts of Java VM/SDK/JRE's
1104 %_jvmlibdir             %{_libdir}/jvm
1105
1106 # Root directory for all architecture independent parts of Java VM/SDK/JRE's
1107 %_jvmdatadir    %{_datadir}/jvm
1108
1109 # Root directory for all configurations parts of Java VM/SDK/JRE's
1110 %_jvmsysconfdir %{_sysconfdir}/jvm
1111
1112 # Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
1113 %_jvmcommonlibdir       %{_libdir}/jvm-common
1114
1115 # Root directory for all common architecture independent parts of Java VM/SDK/JRE's
1116 %_jvmcommondatadir      %{_datadir}/jvm-common
1117
1118 # Root directory for all common configurations parts of Java VM/SDK/JRE's
1119 %_jvmcommonsysconfdir   %{_sysconfdir}/jvm-common
1120
1121 # Directory where arch-specific (JNI) version-independent jars are installed.
1122 %_jnidir                %{_libdir}/java
1123
1124 %java_home              %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})}%java_home
1125
1126 %ant                    JAVA_HOME=%{java_home} CLASSPATH=$CLASSPATH ant
1127 %jar                    %{java_home}/bin/jar
1128 %java                   %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)}%java
1129 %javac                  %{java_home}/bin/javac
1130 %javadoc                %{java_home}/bin/javadoc
1131
1132 %add_jvm_extension      JAVA_LIBDIR=%{buildroot}/%{_javadir}    %{_bindir}/jvmjar -l
1133
1134 %jpackage_script() \
1135 install -d $RPM_BUILD_ROOT%{_bindir}\
1136 cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
1137 #!/bin/sh\
1138 #\
1139 # %{name} script\
1140 # JPackage Project <http://www.jpackage.org/>\
1141 \
1142 # Source functions library\
1143 . %{_javadir}-utils/java-functions\
1144 \
1145 # Source system prefs\
1146 if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
1147     . %{_sysconfdir}/java/%{name}.conf\
1148 fi\
1149 \
1150 # Source user prefs\
1151 if [ -f $HOME/.%{name}rc ]; then\
1152     . $HOME/.%{name}rc\
1153 fi\
1154 \
1155 # Configuration\
1156 MAIN_CLASS=%1\
1157 BASE_FLAGS=%2\
1158 BASE_OPTIONS=%3\
1159 BASE_JARS="%(echo %4 | tr ':' ' ')"\
1160 \
1161 # Set parameters\
1162 set_jvm\
1163 set_classpath $BASE_JARS\
1164 set_flags $BASE_FLAGS\
1165 set_options $BASE_OPTIONS\
1166 \
1167 # Let's start\
1168 run "$@"\
1169 EOF
1170
1171 # jpackage 1.7
1172 # Directory for maven depmaps
1173 #
1174 %_mavendepmapdir /etc/maven
1175 %_mavendepmapfragdir /etc/maven/fragments
1176
1177 #
1178 # add_to_depmap adds an entry to the depmap. The arguments are:
1179 #
1180 # %1 the original groupid
1181 # %2 the original artifact id
1182 # %3 the version
1183 # %4 the new groupid
1184 # %5 the new artifactid
1185 #
1186
1187 %add_to_maven_depmap() \
1188 install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1189 cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1190 <dependency>\
1191     <maven>\
1192         <groupId>%1</groupId>\
1193         <artifactId>%2</artifactId>\
1194         <version>%3</version>\
1195     </maven>\
1196     <jpp>\
1197         <groupId>%4</groupId>\
1198         <artifactId>%5</artifactId>\
1199         <version>%3</version>\
1200     </jpp>\
1201 </dependency>\
1202 \
1203 EOF\
1204 %{nil}
1205
1206 #==============================================================================
1207 #
1208 # update_maven_depmap updates the main maven depmap
1209 #
1210 %update_maven_depmap() \
1211 echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1212 if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1213 cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1214 fi\
1215 echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1216
1217
1218 # PEAR install macros
1219 # Author: Elan Ruusamäe <glen@pld-linux.org>
1220 #
1221 # Usage:
1222 #       %%pear_package_setup ...
1223 #
1224 # -a #   - also unpack SOURCE#. for PEAR bootstrapping
1225 # -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
1226 # -z     - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1227 # -D     - pass -D to %setup (so the build dir is not removed)
1228 # -c     - register channel from local channel.xml file
1229 #
1230 # unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1231 # destination hierarchy. you should copy the tree to buildroot after
1232 # patching/reorganizing with %%pear_package_install.
1233 #
1234 # additionally BUILDROOT is stripped from files and files are converted to UNIX
1235 # line endings.
1236 #
1237 # the pear install process output is recorded to install.log, you should put it
1238 # to %%doc for later debug or just for information.
1239 #
1240 # additionally additional-packages.txt is produced if it was detected that the
1241 # package has optional dependencies. the file format is suitable of displaying
1242 # in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1243 # automatically added for this file.
1244
1245
1246 # records install.log and transforms PEAR names to PLD Linux rpm package names.
1247 %__pear_install_log \
1248 tee install.log \
1249 # make post message of optional packages \
1250 grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,;s,^pear/,php-pear-,;s,^channel://.*/,,' > optional-packages.txt \
1251 if [ -s optional-packages.txt ]; then \
1252         awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1253 else \
1254         rm -f optional-packages.txt \
1255 fi \
1256 %{nil}
1257
1258 # command invoking pear cli
1259 %__pear /usr/bin/pear
1260
1261 %pear_install(a:n:zD) \
1262 %__pear \\\
1263         -c %{builddir}/pearrc \\\
1264         -d doc_dir=/docs \\\
1265         -d temp_dir=/tmp \\\
1266         -d php_dir=%{-c:%{builddir}/}%{php_pear_dir} \\\
1267         -d bin_dir=%{_bindir} \\\
1268         -d data_dir=%{php_pear_dir}/data \\\
1269         -d test_dir=%{php_pear_dir}/tests \\\
1270         install \\\
1271         --packagingroot=%{builddir} \\\
1272         --offline \\\
1273         --nodeps \\\
1274         %{-f:--force} \\\
1275         %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1276         %{-c:cp -a %{builddir}/%{builddir}/%{php_pear_dir} %{builddir}/%(dirname %{php_pear_dir}); rm -rf %{builddir}/%{builddir}; } \
1277 %{nil}
1278
1279 # The main macro.
1280 # using this macro will append optional-packages.txt to the nocompressdoc list
1281 # as it's displayed to user after package install. and adding additional gzip
1282 # dep is just waste ;)
1283 %pear_package_setup(a:n:zDc:) \
1284 %define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1285 %define builddir %{_builddir}/%{srcdir} \
1286 %setup -q -c -T %{-D:-D} -n %{srcdir} \
1287 %{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1288 %{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1289 %{-c:%{__pear} -c pearrc config-set php_dir %{builddir}/%{php_pear_dir}; %__pear -c %{builddir}/pearrc channel-add %{-c*}} \
1290 %pear_install \
1291 %{-z:cd ..} \
1292 cat %{-z:$_N/}.install.log | %__pear_install_log \
1293 \
1294 # undos sources \
1295 find -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
1296 %{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1297 %{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1298 %{nil}
1299
1300 # Copies exctracted PEAR package structure and PEAR registry to buildroot.
1301 # Author: Elan Ruusamäe <glen@pld-linux.org>
1302 %pear_package_install() \
1303 cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1304 find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1305 # help the developer out a little: \
1306 if [ -f _noautoreq ]; then \
1307         echo "AutoReqdep detected:" \
1308         echo "_noautoreq $(cat _noautoreq)" \
1309 fi \
1310 %{nil}
1311
1312
1313 # Register OpenLDAP schema.
1314 # Author: Elan Ruusamäe <glen@pld-linux.org>
1315 #
1316 # Usage:
1317 #   %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1318 #
1319 #  -d specify dependant schemas, separated by comma
1320 #
1321 %openldap_schema_register(d:) \
1322 for schema in %*; do \
1323         if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1324                 %{__sed} -i -e " \
1325                         /^include.*local.schema/{ \
1326                                 iinclude\\t     $schema\
1327                         } \
1328                 " /etc/openldap/slapd.conf \
1329         fi \
1330 done \
1331 # enable dependant schemas \
1332 if [ "%{-d*}" ]; then \
1333         %{__sed} -i -e ' \
1334         /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1335                 s/^#// \
1336         }' /etc/openldap/slapd.conf \
1337 fi \
1338 %{nil}
1339
1340 # Unregister OpenLDAP schema.
1341 # Author: Elan Ruusamäe <glen@pld-linux.org>
1342 #
1343 # Usage:
1344 #   %%openldap_schema_unregister %{schemadir}/horde.schema
1345 #
1346 %openldap_schema_unregister() \
1347 for schema in %*; do \
1348         if grep -q "$schema" /etc/openldap/slapd.conf; then \
1349                 %{__sed} -i -e " \
1350                 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1351                 # for symmetry it would be nice if we disable enabled schemas in post, \
1352                 # but we really can not do that, it would break something else. \
1353                 " /etc/openldap/slapd.conf \
1354         fi \
1355 done \
1356 %{nil}
1357
1358 %env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1359
1360
1361 # Build modules for kernels 2.6
1362 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1363 #
1364 # Usage:
1365 #       %build_kernel_modules -m <modules> -C <directory>
1366 #
1367 #  remember that proper Makefile is still required
1368 # Options:
1369 #  -m <modules> (required) -- comma-separated list of modules to save,
1370 #               without .ko extension, may be placed in subdirectory
1371 #  -C <directory> -- change to <directory> before doing anything
1372 #  -p <arg>, -P <arg> -- arguments passeed to make scripts
1373 #  -c -- do not execute make clean
1374 #  <additional arguments> -- all additional arguments will be passed to
1375 #               make modules
1376 #
1377 # Additional patching supported via here document. Try:
1378 #       %build_kernel_modules -m module <<'EOF'
1379 #       your patch script here
1380 #       EOF
1381 # Don't use it unless patching depends on config options.
1382
1383 # Developer note: don't touch it unless you know how to handle '\'.
1384 # - \ in script expands to nothing
1385 # - \\\ in script expands to \
1386 # - \\\ inside definition expands to nothing
1387 # - \\\\\\\ inside definition expands to \
1388 # - in last line \ has to touch arguments so arguments passing
1389 #   in new lines (using \) will be supported
1390
1391 %build_kernel_modules(p:P:m:C:c)                                                                        \
1392 %{!?-m:%{error:%{0}: Required module name/list missing} exit 1}         \
1393                                                                                                                                         \
1394 %define Opts                                                                                                            \\\\\\\
1395 %if "%{_target_base_arch}" != "%{_arch}"                                                        \\\
1396         %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386"  \\\
1397         CC="%{kgcc}" ARCH=%{_target_base_arch}                                                  \\\
1398         %else                                                                                                                   \\\
1399         ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1400         %endif                                                                                                                  \\\
1401 %else                                                                                                                           \\\
1402         CC="%{kgcc}"                                                                                                    \\\
1403 %endif                                                                                                                          \
1404 %define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1405                 O=$PWD/o %{?with_verbose:V=1} %{Opts}                                           \
1406                                                                                                                                         \
1407 %{?-C:cd %{-C*}}                                                                                                        \
1408 compile() {                                                                                                                     \
1409         local L="<" PATCH_SH;                                                                                   \
1410         [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)"                   \
1411         set -e -x                                                                                                               \
1412         local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1413                                                                                                                                         \
1414 for cfg in ${cfgs:-dist}; do                                        \
1415         [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1                                 \
1416                                                                                                                                         \
1417         rm -rf o                                                                                                                \
1418         install -d o/include/linux o/arch/powerpc/lib                                   \
1419         ln -sf %{_kernelsrcdir}/config-$cfg o/.config                                   \
1420         ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers    \
1421         ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1422                                                                                                                                         \
1423         set +x                                                                                                                  \
1424         [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell    \
1425         set -x                                                                                                                  \
1426                                                                                                                                         \
1427         %if %{with dist_kernel} || %(test -f %{_kernelsrcdir}/scripts/bin2c ; echo $?)  \
1428                 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts                       \\\
1429                         %{-p*} %{-P*}                                                                                   \\\
1430                         %{MakeOpts}                                                                                             \
1431         %else                                                                                                                   \
1432                 install -d o/include/config                                                                     \
1433                 touch o/include/config/MARKER                                                           \
1434                 ln -sf %{_kernelsrcdir}/include/config/auto-$cfg.conf o/include/config/auto.conf        \
1435                 ln -sf %{_kernelsrcdir}/scripts o/scripts                                       \
1436         %endif                                                                                                                  \
1437                                                                                                                                         \
1438         %{!?-c:%{__make} -C %{_kernelsrcdir} clean                                              \\\
1439                 RCS_FIND_IGNORE="-name '*.ko' -o"                                                       \\\
1440                 ${1+"$@"}                                                                                                       \\\
1441                 M=$PWD %{MakeOpts}}                                                                                     \
1442                                                                                                                                         \
1443         %{__make} -C %{_kernelsrcdir} modules                                                   \\\
1444                 ${1+"$@"}                                                                                                       \\\
1445                 M=$PWD %{MakeOpts}                                                                                      \
1446                                                                                                                                         \
1447         for MODULE in {%{-m*},}; do                                                                             \
1448                 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko                           \
1449         done                                                                                                                    \
1450 done                                                                                                                            \
1451 %{?-C:cd -}                                                                                                                     \
1452 }                                                                                                                                       \
1453 compile %{*}\
1454 %{nil}
1455
1456
1457 # Install kernel modules built by %build_kernel_modules
1458 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1459 #
1460 # Usage:
1461 #       %install_kernel_modules -m <modules> -d <directory>
1462 #
1463 # Options:
1464 #  -m <modules> (required) -- comma-separated list of modules to install,
1465 #               without .ko extension, may be placed in subdirectory
1466 #  -d <directory> (required) -- in what subdirectory modules should be
1467 #               installed (eg. misc, kernel/drivers/net)
1468 #  -s <suffix> -- suffix to use when installing modules, useful when module
1469 #               with same name exists in kernel already
1470 #  -n <file> -- name of modprobe config file to use (without .conf extension)
1471 #               for defining aliases, only useful with -s
1472
1473 %install_kernel_modules(m:d:s:n:)                                                                       \
1474 %{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1}          \
1475 %{!?-d:%{error:%{0}: Required module directory missing}exit 1}          \
1476 %{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1477                                                                                                                                         \
1478 %define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}                      \
1479 %define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1480                                                                                                                                         \
1481 __install_kernel_modules() {                                                                            \
1482 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1483                                                                                                                                         \
1484 for MODULE in {%{-m*},}; do                                                                                     \
1485         [ -n "${MODULE}" ] || continue                                                                  \
1486         for cfg in ${cfgs:-dist}; do                                    \
1487                 [ "$cfg" = smp ] && suf=smp || suf=                                                     \
1488                 MNAME=${MODULE##*/}                                                                                     \
1489                 install -D ${MODULE}-$cfg.ko                                                            \\\
1490                         %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                  \
1491                 %{?-s:install -d %{ModprobeD}$suf                                                       \
1492                         echo "alias ${MNAME} ${MNAME}-%{-s*}"                                   \\\
1493                         >> %{ModprobeD}$suf/%{-n*}.conf}                                                \
1494         done                                                                                                                    \
1495 done                                                                                                                            \
1496 }                                                                                                                                       \
1497 __install_kernel_modules                                                                                        \
1498 %{nil}
1499
1500 # patchset macros
1501 # Author: Elan Ruusamäe <glen@pld-linux.org>
1502 #
1503 # Usage:
1504 #   %patchset_source -f <seq(1) format> <start> [<end>]
1505 #   %patchset_patch <start> [<end>]
1506 #
1507 # If <end> is omited, it is assumed to be <start>.
1508 #
1509 # For example in preamble:
1510 #  %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1511 # and in %prep:
1512 #  %patchset_patch 33 44
1513
1514 # generate SourceX urls from range START STOP
1515 # Format can be SINGLE format char of %e, %f, %g, see seq(1)
1516 # The sources start from 10000
1517 %patchset_source(f:b:) %(
1518         base=%{-b*}%{!-b*:10000};
1519         start=$(expr $base + %1);
1520         end=$(expr $base + %{?2}%{!?2:%{1}});
1521         # we need to call seq twice as it doesn't allow two formats
1522         seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1523         seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1524         paste %{tmpdir}/__ps{1,2};
1525         rm -f %{tmpdir}/__ps{1,2};
1526 ) \
1527 %{nil}
1528
1529 # apply sources from %patchset_source
1530 # -p specify -pX for %patch line
1531 # -b base offset: defaults to 10000
1532 %patchset_patch(f:p:b:) %(
1533         base=%{-b*}%{!-b*:10000};
1534         start=$(expr $base + %1);
1535         end=$(expr $base + %{?2}%{!?2:%{1}});
1536         echo ": patchset_patch %1%{?2: to %2}";
1537         seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
1538 ) \
1539 %{nil}
1540
1541 # browser plugins v2
1542 # Author: Elan Ruusamäe <glen@pld-linux.org>
1543 #
1544 # Usage:
1545 #       %browser_plugins_add_browser <name> -p <plugindir>
1546 #
1547 #  <name> (required) -- name of the browser. usually %{name}.
1548 #  -p <plugindir> (required) -- in what directory browser searches for its plugins.
1549 #  -b -- default blacklists
1550 #  -a <arch> override arch
1551 #
1552 # Example:
1553 #   %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1554
1555 %_browserpluginsconfdir         /etc/browser-plugins
1556 %_browserpluginsdir                     %{_libdir}/browser-plugins
1557 %update_browser_plugins         /usr/sbin/update-browser-plugins || :
1558
1559 %browser_plugins_add_browser(p:b:a:) \
1560         browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1561         install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1562         ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1563         blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1564         echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1565         %{-b:cat >> $blacklist_file %{-b*}} \
1566 %{nil}
1567
1568 # Helper for LUA.
1569 # split string separated by space into quoted list
1570 #
1571 # Author: Elan Ruusamäe <glen@pld-linux.org>
1572 #
1573 # %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1574 %__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1575
1576 # adjust /etc/shells by adding and removing shells from there
1577 # Author: Elan Ruusamäe <glen@pld-linux.org>
1578 #
1579 # Usage:
1580 #   %post       -p <lua>
1581 #   %lua_add_etc_shells /bin/sh /bin/pdksh
1582 #
1583 #   %preun      -p <lua>
1584 #   if arg[2] == 0 then
1585 #       %lua_remove_etc_shells /bin/bash /bin/rbash
1586 #   end
1587 #
1588 # Requirements:
1589 # BuildRequires:        rpmbuild(macros) >= 1.462
1590 #
1591
1592 %lua_add_etc_shells() \
1593 t = {}\
1594 f = io.open("/etc/shells", "r")\
1595 if f then\
1596         for l in f:lines() do t[l]=l; end\
1597         f:close()\
1598 end\
1599 for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1600         if not t[s] then\
1601                 print("Adding "..s.." to /etc/shells")\
1602                 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1603         end\
1604 end\
1605 %{nil}
1606
1607 %lua_remove_etc_shells() \
1608 t = {}\
1609 f = io.open("/etc/shells", "r")\
1610 if f then\
1611         for l in f:lines() do t[l]=l; end\
1612         f:close()\
1613 end\
1614 for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1615         print("Removing "..l.." from /etc/shells")\
1616         t[l] = nil\
1617 end\
1618 s=""\
1619 for _, l in pairs(t) do\
1620         s=s..l.."\\n"\
1621 end\
1622 io.open("/etc/shells", "w"):write(s)\
1623 %{nil}
1624
1625 # Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1626 #
1627 # Author: Elan Ruusamäe <glen@pld-linux.org>
1628 #
1629 # Usage:
1630 #   %post       -p %add_etc_shells -p /bin/sh /bin/pdksh
1631 #   %preun      -p %remove_etc_shells -p /bin/sh /bin/pdksh
1632 #
1633 #  -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1634 #
1635 # Requirements:
1636 # BuildRequires:        rpmbuild(macros) >= 1.429
1637 #
1638 %add_etc_shells(p) %{-p:<lua>}\
1639 %{expand:%%lua_add_etc_shells %*}\
1640 %{nil}
1641
1642 %remove_etc_shells(p) %{-p:<lua>}\
1643 %{-p:if arg[2] == 0 then}\
1644 %{expand:%%lua_remove_etc_shells %*}\
1645 %{-p:end} \
1646 %{nil}
1647
1648 # Check syntax for Python files
1649 #
1650 # Author: Elan Ruusamäe <glen@pld-linux.org>
1651 # Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
1652 #
1653 # Usage:
1654 #   %py_lint src
1655 #
1656 # Requirements:
1657 # BuildRequires:        python
1658 # BuildRequires:        rpmbuild(macros) >= 1.469
1659
1660 %py_lint() \
1661 __py_lint() { \
1662 find "$@" -type f -name '*.py' | python -c ' \
1663 import sys \
1664 import compiler \
1665 \
1666 err = 0\
1667 for f in sys.stdin: \
1668         fd = open(f.strip()) \
1669         c = fd.read() \
1670         fd.close() \
1671         try: \
1672                 compiler.parse(c) \
1673         except SyntaxError, e: \
1674                 print "py_lint: %s: %s" % (f.strip(), e) \
1675                 err = err + 1\
1676 \
1677 if err: \
1678         print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
1679         sys.exit(1) \
1680 else: \
1681         print >> sys.stderr,  "py_lint: Found no syntax errors." \
1682 ' \
1683 }; __py_lint %* \
1684 %{nil}
1685
1686 # vim:ts=4 sw=4 noet ft=spec
This page took 0.375129 seconds and 4 git commands to generate.